Show / Hide Table of Contents

# Class GameGui

A class handling many aspects of the in-game UI.

##### Inheritance

System.Object
GameGui

##### Implements

System.IDisposable

##### Inherited Members

System.Object.Equals(System.Object)
System.Object.Equals(System.Object, System.Object)
System.Object.GetHashCode()
System.Object.GetType()
System.Object.MemberwiseClone()
System.Object.ReferenceEquals(System.Object, System.Object)
System.Object.ToString()

###### Namespace: Dalamud.Game.Gui

###### Assembly: Dalamud.dll

##### Syntax

    public sealed class GameGui : IDisposable

### Properties

| Improve this Doc View Source

#### GameUiHidden

Gets a value indicating whether the game UI is hidden.

##### Declaration

    public bool GameUiHidden { get; }

##### Property Value

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### HoveredAction

Gets the action ID that is current hovered by the player. 0 when no action is hovered.

##### Declaration

    public HoveredAction HoveredAction { get; }

##### Property Value

Type | Description
--- | ---
HoveredAction |

| Improve this Doc View Source

#### HoveredItem

Gets or sets the item ID that is currently hovered by the player. 0 when no item is hovered. If > 1.000.000, subtract 1.000.000 and treat it as HQ.

##### Declaration

    public ulong HoveredItem { get; set; }

##### Property Value

Type | Description
--- | ---
System.UInt64 |

### Methods

| Improve this Doc View Source

#### Dispose()

Disables the hooks and submodules of this module.

##### Declaration

    public void Dispose()

| Improve this Doc View Source

#### Enable()

Enables the hooks and submodules of this module.

##### Declaration

    public void Enable()

| Improve this Doc View Source

#### FindAgentInterface(IntPtr)

Find the agent associated with an addon, if possible.

##### Declaration

    public IntPtr FindAgentInterface(IntPtr addon)

##### Parameters

Type | Name | Description
--- | --- | ---
System.IntPtr | addon | The addon address.

##### Returns

Type | Description
--- | ---
System.IntPtr | A pointer to the agent interface.

| Improve this Doc View Source

#### FindAgentInterface(String)

Find the agent associated with an addon, if possible.

##### Declaration

    public IntPtr FindAgentInterface(string addonName)

##### Parameters

Type | Name | Description
--- | --- | ---
System.String | addonName | The addon name.

##### Returns

Type | Description
--- | ---
System.IntPtr | A pointer to the agent interface.

| Improve this Doc View Source

#### FindAgentInterface(Void*)

Find the agent associated with an addon, if possible.

##### Declaration

    public IntPtr FindAgentInterface(void *addon)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Void* | addon | The addon address.

##### Returns

Type | Description
--- | ---
System.IntPtr | A pointer to the agent interface.

| Improve this Doc View Source

#### GetAddonByName(String, Int32)

Gets the pointer to the Addon with the given name and index.

##### Declaration

    public IntPtr GetAddonByName(string name, int index)

##### Parameters

Type | Name | Description
--- | --- | ---
System.String | name | Name of addon to find.
System.Int32 | index | Index of addon to find (1-indexed).

##### Returns

Type | Description
--- | ---
System.IntPtr | IntPtr.Zero if unable to find UI, otherwise IntPtr pointing to the start of the addon.

| Improve this Doc View Source

#### GetUIModule()

Gets a pointer to the game's UI module.

##### Declaration

    public IntPtr GetUIModule()

##### Returns

Type | Description
--- | ---
System.IntPtr | IntPtr pointing to UI module.

| Improve this Doc View Source

#### OpenMapWithMapLink(MapLinkPayload)

Opens the in-game map with a flag on the location of the parameter.

##### Declaration

    public bool OpenMapWithMapLink(MapLinkPayload mapLink)

##### Parameters

Type | Name | Description
--- | --- | ---
MapLinkPayload | mapLink | Link to the map to be opened.

##### Returns

Type | Description
--- | ---
System.Boolean | True if there were no errors and it could open the map.

| Improve this Doc View Source

#### ScreenToWorld(Vector2, out Vector3, Single)

Converts screen coordinates to in-world coordinates via raycasting.

##### Declaration

    public bool ScreenToWorld(Vector2 screenPos, out Vector3 worldPos, float rayDistance = 100000F)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Numerics.Vector2 | screenPos | Screen coordinates.
System.Numerics.Vector3 | worldPos | Converted coordinates.
System.Single | rayDistance | How far to search for a collision.

##### Returns

Type | Description
--- | ---
System.Boolean | True if successful. On false, worldPos's contents are undefined.

| Improve this Doc View Source

#### SetBgm(UInt16)

Set the current background music.

##### Declaration

    public void SetBgm(ushort bgmKey)

##### Parameters

Type | Name | Description
--- | --- | ---
System.UInt16 | bgmKey | The background music key.

| Improve this Doc View Source

#### WorldToScreen(Vector3, out Vector2)

Converts in-world coordinates to screen coordinates (upper left corner origin).

##### Declaration

    public bool WorldToScreen(Vector3 worldPos, out Vector2 screenPos)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Numerics.Vector3 | worldPos | Coordinates in the world.
System.Numerics.Vector2 | screenPos | Converted coordinates.

##### Returns

Type | Description
--- | ---
System.Boolean | True if worldPos corresponds to a position in front of the camera.

### Events

| Improve this Doc View Source

#### HoveredActionChanged

Event that is fired when the currently hovered action changes.

##### Declaration

    public event EventHandler<HoveredAction> HoveredActionChanged

##### Event Type

Type | Description
--- | ---
System.EventHandler<HoveredAction> |

| Improve this Doc View Source

#### HoveredItemChanged

Event that is fired when the currently hovered item changes.

##### Declaration

    public event EventHandler<ulong> HoveredItemChanged

##### Event Type

Type | Description
--- | ---
System.EventHandler<System.UInt64> |

| Improve this Doc View Source

#### UiHideToggled

Event which is fired when the game UI hiding is toggled.

##### Declaration

    public event EventHandler<bool> UiHideToggled

##### Event Type

Type | Description
--- | ---
System.EventHandler<System.Boolean> |

### Implements

System.IDisposable